/***************************************************************************/
/* DESKPRGS.H                                                              */
/* |- FreeGEM Desktop Program Group handling code headers                  */
/* |- Last modified 19991023 by Ben A L Jemmett                            */
/* |                                                                       */
/* |- (C)opyright Ben A L Jemmett 1999.  This code is covered by the GNU   */
/* |     General Public License.  See LICENSE.TXT for more information.    */
/* |                                                                       */
/* +- Revision History:                                                    */
/*    19991023: Created this file.                                         */
/***************************************************************************/

        /* Group state bits - for g_state in GNODE                      */
#define GS_NORM 0               /* Group is at normal size (in GNODE)   */
#define GS_FULL 1               /* Group has been fulled                */
#define GS_ICON 0               /* Group lists as icons                 */
#define GS_TEXT 2               /* Group lists as text                  */
#define GS_MENU 4               /* Group appears as a menu              */

#define GNODE struct gnodeblk
#define INODE struct inodeblk

GNODE
{
        GNODE           *g_next;                /* link to next GNODE   */
        INODE           *i_first;               /* link to first INODE  */
        BYTE            *g_fname;               /* group file name      */
        BYTE            *g_desc;                /* group description    */
        WORD            g_defx;                 /* group's default xpos */
        WORD            g_defy;                 /* group's default ypos */
        WORD            g_defw;                 /* group's default wpos */
        WORD            g_defh;                 /* group's default hpos */
        WORD            g_state;                /* group's state        */
};

INODE
{
        INODE           *i_next;                /* link to next INODE   */
        BYTE            *i_pappl;               /* executable name      */
        BYTE            *i_desc;                /* item description     */
        GNODE           *i_parent;              /* parent program group */
};

